--EXECUTE COMMAND: db2 -tvf createDatabase.db2 
CREATE DATABASE MIGRATION;
CONNECT TO MIGRATION;

CREATE TABLE COUNTRY(
   ID CHAR (2) NOT NULL PRIMARY KEY,
   NAME CHAR (45)
);

CREATE TABLE CITY(
   ID CHAR (2) NOT NULL,
   COUNTRY_ID CHAR(2) NOT NULL,
   NAME CHAR (45),
   CONSTRAINT CITY_COUNTRY_UNIQ UNIQUE (ID,COUNTRY_ID)
);

CREATE TABLE DIALING_CODE (
  COUNTRY VARCHAR(128) NOT NULL,
  CODE VARCHAR(64) NOT NULL,
  PRIMARY KEY  (COUNTRY)
);

CREATE TABLE USER(
	ID INTEGER GENERATED ALWAYS AS IDENTITY PRIMARY KEY NOT NULL,
	USERNAME VARCHAR (30) NOT NULL,
	PASSWORD VARCHAR (30) NOT NULL,
	PHONE_NUMBER BIGINT NOT NULL,
   SEX CHAR (1) NOT NULL,
   AGE SMALLINT NOT NULL,	
   ID_CITY SMALLINT  NOT NULL,
   ID_COUNTRY CHAR(2)  NOT NULL, 
   ZIPCODE INTEGER NOT NULL,
   REGISTRATION_DATE TIMESTAMP,
   CAR_USER CHAR(1),
   CAR_MONDAY  CHAR(1),
   CAR_TUESDAY  CHAR(1),
   CAR_WEDNESDAY  CHAR(1),
   CAR_THURSDAY  CHAR(1),
   CAR_FRIDAY  CHAR(1),
   CAR_SATURDAY  CHAR(1),
   CAR_SUNDAY  CHAR(1),
   PUBLIC_TRANSPORT_USER CHAR (1),
   PUBLIC_MONDAY  CHAR(1),
   PUBLIC_TUESDAY  CHAR(1),
   PUBLIC_WEDNESDAY  CHAR(1),
   PUBLIC_THURSDAY  CHAR(1),
   PUBLIC_FRIDAY  CHAR(1),
   PUBLIC_SATURDAY  CHAR(1),
   PUBLIC_SUNDAY CHAR(1),
CONSTRAINT USER_USERNAME_UNIQ UNIQUE (USERNAME)
);

--/*This is our Cell DataBase, at first was loaded usind LOAD for "openDataBase.org" then we continue to add records also in Registred_outside_cell */
CREATE TABLE CELL(
	ID INTEGER GENERATED ALWAYS AS IDENTITY PRIMARY KEY NOT NULL,
	LAT DECIMAL(23,15),
	LON DECIMAL(23,15),
	MCC INTEGER NOT NULL,
	MNC INTEGER NOT NULL,
	LAC INTEGER NOT NULL,
	CELL_ID INTEGER NOT NULL,
   CONSTRAINT MCC_MNC_LAC_CELLID_UNIQ UNIQUE (MCC,MNC,LAC,CELL_ID)
);

CREATE INDEX IDX_CELL_LAT_LON ON CELL
		(LAT ASC,
		 LON ASC) 
      ALLOW REVERSE SCANS;


--at first was location_trace
--/*This store the current day records, here cellphones insert its records using our exposed WebService */
CREATE TABLE CELL_TRACE(
	USER_ID INTEGER NOT NULL,
	MCC INTEGER ,
	MNC INTEGER ,
	LAC INTEGER ,
	CELL_ID INTEGER,
	INITIAL_DATE TIMESTAMP NOT NULL,
	FINAL_DATE TIMESTAMP NOT NULL,
	STATUS CHAR(10),
	FOREIGN KEY (USER_ID)
 REFERENCES USER (ID)
	ON DELETE CASCADE
);

--/*This Store all Records history; using for show tracks... mapping */
CREATE TABLE LOCATION_TRACE(
	USER_ID INTEGER NOT NULL,
	LAT DECIMAL(23,15) NOT NULL,
	LON DECIMAL(23,15) NOT NULL,
	INITIAL_DATE TIMESTAMP NOT NULL,
	FINAL_DATE TIMESTAMP NOT NULL,
	STATUS CHAR(10),
	FOREIGN KEY (USER_ID)
        REFERENCES USER(ID)
	ON DELETE CASCADE
);
CREATE INDEX IDX_LOCATIONTRACE_ID_LAT_LON ON LOCATION_TRACE
  (USER_ID, LAT ASC, LON ASC)
     ALLOW REVERSE SCANS;

